﻿
local chatfadehide	                = false
local chatbackgroundhide			= true
local flashtabfade                		        = true
local uinoticetrue			= false
local csounds                   	        = true
local altclickinvite            	                = false
local eboxbottom                	= false
local fontoutline                   	        = false
local hidechannelnames                                  = true
local hideotherchannelnames             = true
local hideboxbground                            = true
local hideurl                                           = true
local hidechatcopy                      = true
local friendshide                                       = false
local removechannelspam                         = false
local bnthide                         = false
--[[-----------------------------------------------------------------------------

Setting descriptions:

To disable an option set it to false or true.

Chat fade hide.
    Set to false, to not Fade out the chat frames completely instead
	of partially.

Chat background hide.
    Set to false, to not Remove chat background which shows on hovering.

Flash tab fade.
	Set to false to fade tab flashing.

Ui notice true.
	Error notification frame, Set to false to turn off.
        (WTS,WTB,LF,LFG,LFM.You have been outbid,group has been disbanded,instance will reset)

Csounds.
	Chat Sounds, Set to false to turn off.

Alt click invite.
	Alt click invite to party, Set to false to turn off.
        (hold alt and left click to invite from the chat)

Eboxbottom.
	Set to true to have the editbox show at the bottom.

Font outline.
	Set to true to have the Chat text bold.

Hide channel names.
        Set to false to hide the channelnames.

Hide other channel names.
        Set to false to hide the channelnames this may fix for other language "let me know".

Hide box bground.
        Set to false to show the editbox background. "A white border will be there still working on this".

Hide scroll flash.
       Set to false to hide the chat flash icon.

Hide url.
       Set to false to hide url copy.

Hide chat copy.
       Set to false to hide the chat copy.

Friends hide.
       Set to true to hide the friends icon.

Remove Channel Spam.
       Mutes General and LocalDefense channels while inside instances.

bnthide.
       Set to true to hide the BNToastFrame.
-------------------------------------------------------------------------------]]

--[[-----------------------------------------------------------------------------
Full Screen Toogle.
Justify --"LEFT","RIGHT", or "CENTER" ChatFrames 1 - 10 --(combatlog) 2,RIGHT.
Real ID Frame.
-------------------------------------------------------------------------------]]
BINDING_HEADER_FULLSCREENTOOGLE = "FullScreenToogle";

ChatFrame2:SetJustifyH("RIGHT")

--[[-----------------------------------------------------------------------------
BNToastFrame.
-------------------------------------------------------------------------------]]
if bnthide then
  BNToastFrame:SetScript("OnShow", BNToastFrame.Hide)
  BNToastFrame:Hide()
 else
  BNToastFrame:SetClampedToScreen(true)
  BNToastFrame:SetClampRectInsets(-15,15,15,-15)
end

--[[-----------------------------------------------------------------------------
more chat font sizes.
-------------------------------------------------------------------------------]]
  for i = 1, 23 do
    CHAT_FONT_HEIGHTS[i] = i+7
  end

--[[-----------------------------------------------------------------------------
Chat background hide.
-------------------------------------------------------------------------------]]
if chatbackgroundhide then
for i=1,10 do
	_G['ChatFrame'..i]:SetFading(false)
   end
end

--[[-----------------------------------------------------------------------------
Disable tab flashing.
-------------------------------------------------------------------------------]]
if flashtabfade then
  FCF_FlashTab = function() end
  FCFTab_UpdateAlpha = function() end
end

--[[-----------------------------------------------------------------------------
Sticky Channels, 0 off, 1 on.
-------------------------------------------------------------------------------]]
local StickyTypeChannels = {
  SAY = 1,
  YELL = 0,
  EMOTE = 0,
  PARTY = 1, 
  RAID = 1,
  GUILD = 1,
  OFFICER = 1,
  WHISPER = 1,
  CHANNEL = 1,
};

for k, v in pairs(StickyTypeChannels) do
    ChatTypeInfo[k].sticky = v;
end

--[[-----------------------------------------------------------------------------
ALWAYS turn off profanity filter.
-------------------------------------------------------------------------------]]
if BNConnected() then
   BNSetMatureLanguageFilter(false)
end

--[[-----------------------------------------------------------------------------
Chat fade hide.
-------------------------------------------------------------------------------]]
if chatfadehide then
	CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0
	CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 0
	CHAT_FRAME_BUTTON_FRAME_MIN_ALPHA = 0
	for i=1, 10 do
		local tab = _G[format("%s%d%s", "ChatFrame", i, "Tab")]
		tab:SetAlpha(0)
		tab.noMouseAlpha = 0
	end
end

--[[-----------------------------------------------------------------------------
Font outline.
-------------------------------------------------------------------------------]]
if fontoutline then 
	for i = 1, 10 do
		local cF = _G[format("%s%d", "ChatFrame", i)]
		local font, size = cF:GetFont()
		cF:SetFont(font, size, "OUTLINE")
	end
end

--[[-----------------------------------------------------------------------------
Scrolldown.
-------------------------------------------------------------------------------]]
FloatingChatFrame_OnMouseScroll = function(self, dir)
  if(dir > 0) then
    if(IsShiftKeyDown()) then self:ScrollToTop()
    else
      self:ScrollUp() end
  else
    if(IsShiftKeyDown()) then self:ScrollToBottom()
    else
      self:ScrollDown() end
  end
end

--[[-----------------------------------------------------------------------------
Remove Channel Spam.
-------------------------------------------------------------------------------]]
if removechannelspam then
local rcs = CreateFrame("frame")
rcs:RegisterEvent("PLAYER_ENTERING_WORLD")
rcs:SetScript("OnEvent", function()
	if IsInInstance() then
		ChatFrame_RemoveChannel(DEFAULT_CHAT_FRAME, "General")
		ChatFrame_RemoveChannel(DEFAULT_CHAT_FRAME, "LocalDefense")
	else
		ChatFrame_AddChannel(DEFAULT_CHAT_FRAME, "General")
		ChatFrame_AddChannel(DEFAULT_CHAT_FRAME, "LocalDefense")
	end
    end)
end

--[[-----------------------------------------------------------------------------
Remove the annoying guild loot messages by replacing them with the original ones
-------------------------------------------------------------------------------]]
	YOU_LOOT_MONEY_GUILD = YOU_LOOT_MONEY
	LOOT_MONEY_SPLIT_GUILD = LOOT_MONEY_SPLIT

--[[-----------------------------------------------------------------------------
UI notice.
-------------------------------------------------------------------------------]]
if uinoticetrue then
	local notify = {
		["[Ll][Ff][Gg]"] = "|cff00ff00LFG",
		["[Ll][Ff][Mm]"] = "|cff00ff00LFM",
		["[Ww][Tt][Bb]"] = "|cff0000ffWTB",
		["[Ww][Tt][Ss]"] = "|cffff0000WTS",
		["^A buyer has been found for your auction of "] = false,
		["^This instance will reset in "] = false,
		["^You have been outbid on "] = false,
		["^Your group has been disbanded.$"] = false,
	}
	local framea = CreateFrame('Frame')
	framea:SetScript('OnEvent', function(self, event, message, sender)
		for pattern, tag in pairs(notify) do
			if message:find(pattern) then
				if tag then
					UIErrorsFrame:AddMessage(tag .. ": |cffcccccc" .. sender .. ": |cffffff00" .. message, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
				else
					UIErrorsFrame:AddMessage("|cffffff00" .. message, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
				end
				PlaySound('MapPing')
				break
			end
		end
	end)
	framea:RegisterEvent('CHAT_MSG_CHANNEL')
end

--[[-----------------------------------------------------------------------------
Misc functions (Frame size/move,Arrow keys,editbox to the top).
-------------------------------------------------------------------------------]] 
if hideboxbground then
        for i = 1, NUM_CHAT_WINDOWS do
        local editBoxleft = _G[format("%s%d%s", "ChatFrame", i, "EditBoxLeft")]
        local editBoxright = _G[format("%s%d%s", "ChatFrame", i, "EditBoxRight")]
        local editBoxmid = _G[format("%s%d%s", "ChatFrame", i, "EditBoxMid")]
			editBoxleft:SetAlpha(0)
			editBoxright:SetAlpha(0)
			editBoxmid:SetAlpha(0)
end
        end

	--Classic mode hides the editbox when not in use, IM mode fades it out
	--since we move the editbox above the chat tabs, we don't want it always showing
    SetCVar("chatStyle", "classic")
	for i = 1, 10 do
		local eb =  _G[format("%s%d%s", "ChatFrame", i, "EditBox")]
		local cfs = _G[format("%s%d", "ChatFrame", i)]
	        --Allow resizing chatframes to whatever size you wish!
		cfs:SetMinResize(100,10)
		cfs:SetMaxResize(0,0)
	        --Allow the chat frame to move to the end of the screen
                cfs:SetClampRectInsets(0,0,0,0)
		eb:SetAltArrowKeyMode(false)
if eboxbottom then
		eb:ClearAllPoints()
		eb:SetPoint("TOPLEFT",  cfs, "BOTTOMLEFT",  -5, 0)
		eb:SetPoint("TOPRIGHT", cfs, "BOTTOMRIGHT", 5, 0)
		eb:Hide() --call this incase we're just changing to classic mode for the first time
else
		eb:ClearAllPoints()
		eb:SetPoint("BOTTOMLEFT",  cfs, "TOPLEFT",  -5, 0)
		eb:SetPoint("BOTTOMRIGHT", cfs, "TOPRIGHT", 5, 0)
		eb:Hide() --call this incase we're just changing to classic mode for the first time
	end
end

--[[-----------------------------------------------------------------------------
Buttons.
-------------------------------------------------------------------------------]] 
local dummy = function(self) self:Hide() end
for i = 1, NUM_CHAT_WINDOWS do
	local n = ("ChatFrame%d"):format(i)
	local f = _G[n]
		
if f then
	_G[n.."ButtonFrameUpButton"]:Hide()
	_G[n.."ButtonFrameUpButton"]:SetScript("OnShow", dummy)
	_G[n.."ButtonFrameDownButton"]:Hide()
	_G[n.."ButtonFrameDownButton"]:SetScript("OnShow", dummy)
	_G[n.."ButtonFrame"]:Hide()
	_G[n.."ButtonFrame"]:SetScript("OnShow", dummy)
     if _G[n.."ButtonFrameMinimizeButton"] then
     --this button doesn't always appear for all chat frames
	_G[n.."ButtonFrameMinimizeButton"]:Hide()
	_G[n.."ButtonFrameMinimizeButton"]:SetScript("OnShow", dummy)
	end
    end
end 

--if friendshide then
        ChatFrameMenuButton:HookScript("OnShow", ChatFrameMenuButton.Hide)
        ChatFrameMenuButton:Hide()
        FriendsMicroButton:HookScript("OnShow", FriendsMicroButton.Hide)
        FriendsMicroButton:Hide()
    --else
        --FriendsMicroButton:SetAlpha(.6)
        --FriendsMicroButton:ClearAllPoints()
        --FriendsMicroButton:SetPoint('TOPRIGHT', ChatFrame1)
       --ChatFrameMenuButton:SetAlpha(.6)
        --ChatFrameMenuButton:ClearAllPoints()
        --ChatFrameMenuButton:SetPoint('TOPRIGHT', ChatFrame1, 0, -20)

        --ChatMenu:SetPoint('BOTTOMLEFT', FriendsMicroButton, 'TOPRIGHT')
--end


--[[-----------------------------------------------------------------------------
Channels.
-------------------------------------------------------------------------------]] 
if hideotherchannelnames then
CHAT_SAY_GET = "[S] %s: "
CHAT_YELL_GET = "[Y] %s: "
CHAT_WHISPER_GET = "[F] %s: "
CHAT_WHISPER_INFORM_GET = "[T] %s: "

CHAT_FLAG_AFK = "[AFK] "
CHAT_FLAG_DND = "[DND] "
CHAT_FLAG_GM = "[GM] "

CHAT_MONSTER_PARTY_GET = CHAT_PARTY_GET
CHAT_MONSTER_SAY_GET = CHAT_SAY_GET
CHAT_MONSTER_WHISPER_GET = CHAT_WHISPER_GET
CHAT_MONSTER_YELL_GET = CHAT_YELL_GET

--CHAT_BN_WHISPER_INFORM_GET = "T %s "
--CHAT_BN_WHISPER_GET = "F %s "

--_G.ERR_FRIEND_ONLINE_SS = "|Hplayer:%s|h[%s]|h "
--_G.ERR_FRIEND_OFFLINE_S = "%s "
end

if hidechannelnames then
local gsub = gsub
local time = _G.time
local newAddMsg = {}

	local rplc = {
		"[GEN]", --General
		"[T]", --Trade
		"[WD]", --WorldDefense
		"[LD]", --LocalDefense
		"[LFG]", --LookingForGroup
		"[GR]", --GuildRecruitment
		"[I]", --Instance
		"[IL]", --Instance Leader
		"[G]", --Guild
		"[P]", --Party
		"[PL]", --Party Leader
		"[PL]", --Party Leader (Guide)
		"[O]", --Officer
		"[R]", --Raid
		"[RL]", --Raid Leader
		"[RW]", --Raid Warning
		"[%1]", --Custom Channels
	}

	local chn = {
		"%[%d0?%. General.-%]",
		"%[%d0?%. Trade.-%]",
		"%[%d0?%. WorldDefense%]",
		"%[%d0?%. LocalDefense.-%]",
		"%[%d0?%. LookingForGroup%]",
		"%[%d0?%. GuildRecruitment.-%]",
		gsub(CHAT_INSTANCE_CHAT_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_INSTANCE_CHAT_LEADER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_GUILD_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_PARTY_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_PARTY_LEADER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_PARTY_GUIDE_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_OFFICER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_RAID_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_RAID_LEADER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		gsub(CHAT_RAID_WARNING_GET, ".*%[(.*)%].*", "%%[%1%%]"),
		"%[(%d0?)%. (.-)%]", --Custom Channels
	}

	local L = GetLocale()
	if L == "ruRU" then --Russian
		chn[1] = "%[%d0?%. Общий.-%]"
		chn[2] = "%[%d0?%. Торговля.-%]"
		chn[3] = "%[%d0?%. Оборона: глобальный%]" --Defense: Global
		chn[4] = "%[%d0?%. Оборона.-%]" --Defense: Zone
		chn[5] = "%[%d0?%. Поиск спутников%]"
		chn[6] = "%[%d0?%. Гильдии.-%]"
	elseif L == "deDE" then --German
		chn[1] = "%[%d0?%. Allgemein.-%]"
		chn[2] = "%[%d0?%. Handel.-%]"
		chn[3] = "%[%d0?%. Weltverteidigung%]"
		chn[4] = "%[%d0?%. LokaleVerteidigung.-%]"
		chn[5] = "%[%d0?%. SucheNachGruppe%]"
		chn[6] = "%[%d0?%. Gildenrekrutierung.-%]"
	elseif L == "frFR" then --French
		chn[1] = "%[%d0?%. Général.-%]"
		chn[2] = "%[%d0?%. Commerce.-%]"
		chn[3] = "%[%d0?%. DéfenseUniverselle%]"
		chn[4] = "%[%d0?%. DéfenseLocale.-%]"
		chn[5] = "%[%d0?%. RechercheDeGroupe%]"
		chn[6] = "%[%d0?%. RecrutementDeGuilde.-%]"
	elseif L == "zhTW" then --Traditional Chinese
		chn[1] = "%[%d0?%. 綜合.-%]"
		chn[2] = "%[%d0?%. 交易.-%]"
		chn[3] = "%[%d0?%. 世界防務%]"
		chn[4] = "%[%d0?%. 本地防務.-%]"
		chn[5] = "%[%d0?%. 尋求組隊%]"
		chn[6] = "%[%d0?%. 公會招募.-%]"
	elseif L == "koKR" then --Korean
		chn[1] = "%[%d0?%. 일반.-%]"
		chn[2] = "%[%d0?%. 거래.-%]"
		chn[3] = "%[%d0?%. 광역수비%]"
		chn[4] = "%[%d0?%. 지역수비.-%]"
		chn[5] = "%[%d0?%. 파티찾기%]"
		chn[6] = "%[%d0?%. 길드찾기.-%]"
	end

	local AddMessage = function(frame, text, ...)
	for i = 1, 17 do	
		text = gsub(text, chn[i], rplc[i])
	end

	--If Blizz timestamps is enabled, stamp anything it misses
	if CHAT_TIMESTAMP_FORMAT and not text:find("^|r") then
		text = BetterDate(CHAT_TIMESTAMP_FORMAT, time())..text
	end
	text = gsub(text, "%[(%d0?)%. .-%]", "[%1]") --custom channels
	return newAddMsg[frame:GetName()](frame, text, ...)
end

	for i = 1, 10 do
		local fcl = _G[format("%s%d", "ChatFrame", i)]
		--skip combatlog and frames with no messages registered
		if i ~= 2 then -- skip combatlog
			newAddMsg[format("%s%d", "ChatFrame", i)] = fcl.AddMessage
			fcl.AddMessage = AddMessage
		end
	end
end

--[[-----------------------------------------------------------------------------
URL Copy.
-------------------------------------------------------------------------------]] 
if hideurl then
local SetItemRef_orig = SetItemRef

function doColor(url)
	url = " |cff99FF33|Hurl:"..url.."|h["..url.."]|h|r "
	return url
end

function urlFilter(self, event, msg, author, ...)
	if strfind(msg, "(%a+)://(%S+)%s?") then
		return false, gsub(msg, "(%a+)://(%S+)%s?", doColor("%1://%2")), author, ...
	end
	if strfind(msg, "www%.([_A-Za-z0-9-]+)%.(%S+)%s?") then
		return false, gsub(msg, "www%.([_A-Za-z0-9-]+)%.(%S+)%s?", doColor("www.%1.%2")), author, ...
	end
	if strfind(msg, "([_A-Za-z0-9-%.]+)@([_A-Za-z0-9-]+)(%.+)([_A-Za-z0-9-%.]+)%s?") then
		return false, gsub(msg, "([_A-Za-z0-9-%.]+)@([_A-Za-z0-9-]+)(%.+)([_A-Za-z0-9-%.]+)%s?", doColor("%1@%2%3%4")), author, ...
	end
	if strfind(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?):(%d%d?%d?%d?%d?)%s?") then
		return false, gsub(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?):(%d%d?%d?%d?%d?)%s?", doColor("%1.%2.%3.%4:%5")), author, ...
	end
	if strfind(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%s?") then
		return false, gsub(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%s?", doColor("%1.%2.%3.%4")), author, ...
	end
	if strfind(msg, "[wWhH][wWtT][wWtT][\46pP]%S+[^%p%s]") then
		return false, gsub(msg, "[wWhH][wWtT][wWtT][\46pP]%S+[^%p%s]", doColor("%1")), author, ...
	end
end

StaticPopupDialogs["LINKME"] = {
	text = "URL COPY",
	button2 = CANCEL,
	hasEditBox = true,
    hasWideEditBox = true,
	timeout = 0,
	exclusive = 1,
	hideOnEscape = 1,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
	whileDead = 1,
	maxLetters = 255,
}

local SetHyperlink = _G.ItemRefTooltip.SetHyperlink
function _G.ItemRefTooltip:SetHyperlink(link, ...)
	if link and (strsub(link, 1, 3) == "url") then
		local url = strsub(link, 5)
		local dialog = StaticPopup_Show("LINKME")
		local editboxa = _G[dialog:GetName().."EditBox"]  
		
		editboxa:SetText(url)
		editboxa:SetFocus()
		editboxa:HighlightText()
		
		local button = _G[dialog:GetName().."Button2"]
		button:ClearAllPoints()
		button:SetPoint("CENTER", editboxa, "CENTER", 0, -30)
		
		return
     end
	 
	 SetHyperlink(self, link, ...)
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND_LEADER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_CONVERSATION", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", urlFilter)

ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", urlFilter)
end

--[[-----------------------------------------------------------------------------
Chat copy.
-------------------------------------------------------------------------------]]
if hidechatcopy then
local frame = CreateFrame("Frame", "wCopyFrame", UIParent)
frame:SetBackdrop({
	bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
	edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
	edgeSize = 16, tileSize = 16, tile = true,
	insets = { left = 1, right = 1, top = 1, bottom = 1 }
})
frame:SetBackdropColor(0,0,0,1)
frame:SetWidth(650)
frame:SetHeight(500)
frame:SetPoint("CENTER", UIParent, "CENTER")
frame:Hide()
frame:SetFrameStrata("DIALOG")

local scrollArea = CreateFrame('ScrollFrame', "wCopyScroll", frame, 'UIPanelScrollFrameTemplate')
scrollArea:SetPoint("TOPLEFT", frame, "TOPLEFT", 8, -5)
scrollArea:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -30, 5)

	-- XXX temp till 6.0
	local group = scrollArea:CreateAnimationGroup()
	local update = group:CreateAnimation()
	group:SetScript("OnFinished", function() wCopyScroll:SetVerticalScroll((wCopyScroll:GetVerticalScrollRange()) or 0) end)
	update:SetOrder(1)
	update:SetDuration(0.25)
	wCopyScroll.ScrollToBottom = group

local editBox = CreateFrame("EditBox", "wCopyBox", frame)
editBox:SetMultiLine(true)
editBox:SetMaxLetters(99999)
editBox:EnableMouse(true)
editBox:SetAutoFocus(false)
editBox:SetFontObject(ChatFontNormal)
editBox:SetWidth(620)
editBox:SetHeight(495)
editBox:SetScript("OnEscapePressed", function(f) f:GetParent():GetParent():Hide() f:SetText("") end)

scrollArea:SetScrollChild(editBox)

local close = CreateFrame('Button', "wCloseButton", frame, 'UIPanelCloseButton')
close:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 25)

local CopyChat = function(self, chatTab)
	local chatFrame = _G['ChatFrame' .. chatTab:GetID()]
	local numMessages = chatFrame:GetNumMessages()
	if numMessages >= 1 then
		local GetMessageInfo = chatFrame.GetMessageInfo
		local text = GetMessageInfo(chatFrame, 1)
		for index = 2, numMessages do
			text = text .. "\n" .. GetMessageInfo(chatFrame, index)
		end
		frame:Show()
		editBox:SetText(text)
	end
end

hooksecurefunc('FCF_Tab_OnClick', function(self)
	local info = UIDropDownMenu_CreateInfo()
	info.text = "Copy Chat Contents"
	info.notCheckable = true
	info.func = CopyChat
	info.arg1 = self
	UIDropDownMenu_AddButton(info)
end)
end

--[[-----------------------------------------------------------------------------
Chat Sounds.
-------------------------------------------------------------------------------]]
if csounds then
local name, ns = ...
local mediaPath = [=[Interface\AddOns\wChat\media\]=]
local name = UnitName'player'
local evtsounds = {
	["CHAT_MSG_GUILD"] = "Kachink",
	["CHAT_MSG_OFFICER"] = "Link",
	["CHAT_MSG_PARTY"] = "pop1",
	["CHAT_MSG_PARTY_LEADER"] = "pop2",
	["CHAT_MSG_RAID"] = "Text2",
	["CHAT_MSG_WHISPER"] = "Heart",
	["CHAT_MSG_GMWHISPER"] = "gasp",
	["CHAT_MSG_RAID_LEADER"] = "Choo",
	["CHAT_MSG_BATTLEGROUND"] = "switchy",
	["CHAT_MSG_BATTLEGROUND_LEADER"] = "doublehit",
	["CHAT_MSG_CHANNEL"] = true, --dummy,
	["CHAT_MSG_REALID"] = "Heart"
}

local cs = CreateFrame'Frame'
cs:SetScript('OnEvent', function(self, event, ...)
	local msg, author, lang, channel = ...
	if author == name then return end
	if event == "CHAT_MSG_CHANNEL" then
		-- TODO
	else
		local sound = mediaPath..evtsounds[event]..'.mp3'
		PlaySoundFile(sound)
	end
end)

for event, sound in pairs(evtsounds) do
	cs:RegisterEvent(event)
   end
end

--[[-----------------------------------------------------------------------------
Alt click invite.
-------------------------------------------------------------------------------]]
if altclickinvite then
	hooksecurefunc("SetItemRef", function(link)
		if IsAltKeyDown() then
			local player = link:match("^player:([^:]+)")
			InviteToGroup(player)
			-- We use a secure hook to stay clean (avoid taint), but this means a whisper window will open, so we close it.
			ChatEdit_OnEscapePressed(ChatFrame1EditBox)
		end
	end)
end

print("|cff3399FFw|rChat: Loaded|r");
